#include "VSensor.h" 
#include <signal.h> 
#include <direct.h> 
#pragma comment(lib, "VSensorSDK.lib")
using namespace std;
using namespace VSENSOR;
int main()
{
    //获取相对路径
    char cwd[200];
    if (_getcwd(cwd, 200) == nullptr)
    {
        printf("get path failed\n");
    }
    //实例化设备
    VSensor* pVSensor = new VSensor();
    //获取sdk版本
    string version = string();
    pVSensor->GetSdkVersionString(version);
    printf("sdk version: %s\n", version.c_str());
    //获取设备列表
    VSensorCameraInfo cameraList[20];
    int num = 0;
    pVSensor->GetDeviceList(cameraList, &num);
    for (int i = 0; i < num; i++)
    {
        printf("device num %d : list[%d] = %s\n", i, i, cameraList[i].CameraName);
    }
    //连接设备，0为连接第一台设备  
    int status = pVSensor->DeviceConnect(0);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("connect device failed status = %d\n", status);
        system("pause");
    }
    //回调注册
    pVSensor->RegisterCallbackFuncGetResult(std::bind([pVSensor, cwd](VSensorResult* result)
        {
            pVSensor->Save3DCloud(string(cwd) + "//callback.pcd", result, emVSensorPointType::POINT_TYPR_DISORDER);
            pVSensor->SaveGrayMap(string(cwd) + "//callback.png", result, emVSensorCameraType::TYPE_GRAY);
        }, std::placeholders::_1));
    //设备参数初始化，仅初次上电时需要进行此操作且该函数需要等待15s
    printf("waiting for parameter init...\n");
    status = pVSensor->DeviceParameterInit();
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("parameter init failed, status = %d\n", status);
        system("pause");
    }
    //设置为采集模式
    status = pVSensor->SetCaptureMode(emVSensorCaptureMode::MODE_CAPTURE);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("set capture mode failed, status = %d\n", status);
        system("pause");
    }
    //单次采集
    printf("start single capture...\n");
    VSensorResult *pResult = new VSensorResult;
    status = pVSensor->SingleRestruction(pResult, emVSensorCaptureOutputMode::OUTPUT_MODE_ALL);
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("single restruction failed, status = %d\n", status);
        system("pause");
    }
    //反初始化设备
    status = pVSensor->DeviceUnInit();
    if (status != CAMERA_STATUS_SUCCESS)
    {
        printf("device release failed, status = %d\n", status);
        system("pause");
    }
    delete pResult;
    delete pVSensor;
    printf("run success\n");
    system("pause");
    return 0;
}